=== modified file 'fai/cmdutil.py'
--- fai/cmdutil.py	2005-09-13 10:46:27 +0000
+++ fai/cmdutil.py	2005-09-13 10:49:57 +0000
@@ -1137,11 +1137,13 @@
             # baz does not know
             # guess
             ancestor = namespace_previous(log.revision)
-        if ancestor is not None and ancestor != '<<<no previous revision>>>':
+        if ancestor is not None:
             indirect.append(ancestor)
     return [log for log in logs if not log.revision in indirect]
 
 def namespace_previous(revision):
+    if revision.patchlevel == 'base-0':
+        return None
     if revision.patchlevel == 'patch-1':
         return revision.version['base-0']
     if revision.patchlevel.startswith('patch'):
@@ -1152,7 +1154,10 @@
                            "version-0 patch")
     if revision.patchlevel == 'version-1':
         return revision.version['version-0']
-    print pybaz.NameParser
+    if revision.patchlevel.startswith('version'):
+        level = int(revision.patchlevel[len('version-'):]) -1
+        return revision.version['version-%d' % level]
+    raise NotImplementedError
 
 def require_version_exists(version, spec):
     if not version.exists():

=== modified file 'tests/test_baz_import.py'
--- tests/test_baz_import.py	2005-09-13 10:46:27 +0000
+++ tests/test_baz_import.py	2005-09-13 10:49:57 +0000
@@ -341,3 +341,7 @@
     def test_version1_version0(self):
         self.assertEqual(namespace_previous(self.version['version-1']),
                          self.version['version-0'])
+
+    def test_version3000_patch2999(self):
+        self.assertEqual(namespace_previous(self.version['version-3000']),
+                         self.version['version-2999'])

